#!/usr/bin/perl

use strict;
use DBI;

my $db;

opendb();

#create();
#create($db);

#call subfunctions here, just test cases for now
#populateEIP($db);
#auth($db, "127.0.0.101", "2h.hd.h2.hj.74", 5050);
#print checkAuth($db, "127.0.0.101");
#print checkAuth($db, "127.0.0.1");
#removeAuth($db, "127.0.0.101");
#checkAuth($db, "127.0.0.101");
#deElevate($db, "123", "456", "sd", "sg", 50, 80, "proto", 7878787);
#getEIPs($db, "sg", 80);
#print getStatus($db, "123");
#updateStatus($db, "123", "3");
#print getStatus($db, "123");
#deElevate($db, "672", "837", "273", "fd", 50, 80, "proto", 7878787);
#deElevate($db, "12", "46", "s", "12e", 50, 80, "proto", 7878787);
#reElevate($db, "123");
#free($db, "123");
#get($db);

#$db->disconnect();

sub opendb{
    $db = DBI->connect(
        "dbi:SQLite:dbname=database.db",
        "",
        "",
        { RaiseError => 1 },
    ) or die $DBI::errstr;
}

sub get_db {
    return $db;
}

#creates the tables
sub create {
    #my $db = shift;
    #drop all tables
    $db->do("DROP TABLE IF EXISTS auth_host");
    $db->do("DROP TABLE IF EXISTS EIP_free");
    $db->do("DROP TABLE IF EXISTS de_elevated");
    #create tables
    $db->do("CREATE TABLE auth_host (PIP TEXT PRIMARY KEY, MAC TEXT NOT NULL, timeAuth INT NOT NULL)");
    #$db->do("CREATE TABLE auth_host (PIP TEXT PRIMARY KEY, MAC TEXT UNIQUE NOT NULL, timeAuth INT NOT NULL)");
    $db->do("CREATE TABLE EIP_free (EIP TEXT PRIMARY KEY)");
    $db->do("CREATE TABLE de_elevated (srcEIP TEXT PRIMARY KEY, dstEIP text UNIQUE NOT NULL, srcPIP TEXT NOT NULL, dstPIP TEXT NOT NULL, srcPort INT NOT NULL, dstPort INT NOT NULL, protocol TEXT NOT NULL, timeCreated INT NOT NULL, status INT)");
    #populate the EIP table if necessary
    populateEIP();
}

sub populateEIP {
    #my $db = shift;
    #set up for a range of 10.0.1.0 to 10.0.1.255 for now
    # CRT EDIT
    # range [10.22.10.0, 10.22.255.254] -- I think DHCP does 10.22.0.0/24. This gives up wiggle for for DHCP to grow
    my $low1 = 10;
    my $high1 = 10;
    my $low2 = 22;
    my $high2 = 22;
    my $low3 = 10;
    my $high3 = 255;
    my $low4 = 0;
    my $high4 = 254;
    $low4++; #leave room for network address
    my $min1 = $low1;
    my $min2 = $low2;
    my $min3 = $low3;
    my $min4 = $low4;
    while ($low1 <= $high1){
        while ($low2 <= $high2){
            while ($low3 <= $high3){
                while ($low4 <= $high4){
                    #this is the address of the first EIP
                    my $ip = $low1 . "." . $low2 . "." . $low3 . "." . $low4;
                    free($ip);
                    $low4 = $low4 + 4;
                }
                $low3++;
                $low4 = $min4;
            }
            $low2++;
            $low3 = $min3;
        }
        $low1++;
        $low2 = $min2;
    }

}

#functions for authentification of hosts
#authorize this host
sub auth {
    #my $db = shift;
    my $PIP = shift;
    my $MAC = shift;
    my $time = shift;

    #my $query = $db->prepare("SELECT * FROM auth_host WHERE MAC = '" . $MAC . "';");
    #$query->execute();
    #my $flag=1;
    #my $row;
    #while ($row = $query->fetchrow_arrayref()) {
    #    $query->finish();
#	    print "Client $PIP double authenticated\n";
#	$flag=0;
 #   }
  #  if($flag){
	    my $str = "INSERT INTO auth_host VALUES('" . $PIP . "', '" . $MAC . "', '" . $time . "');";
	    eval{ $db->do($str); } or do { print("Client already authenticated?\n"); }
    #}
}

#check if this host is authorized, retuns 0 if not authorized, 1 if authorized
sub checkAuth {
    #my $db = shift;
    my $PIP = shift;
	print "Attempting to check authentication for client PIP=$PIP\n";
    my $query = $db->prepare("SELECT * FROM auth_host WHERE PIP = '" . $PIP . "';");
	print "Executing query\n";
    $query->execute();
	print "Executed successfully\n";
    my $row;
    while ($row = $query->fetchrow_arrayref()) {
        $query->finish();
        print "Client $PIP was authenticated\n";
        return "1";
    }
	print "Client $PIP failed to be authenticated\n";
    return "0";

}

#unauthorize this host
sub removeAuth {
    #my $db = shift;
    my $PIP = shift;
    my $str = "DELETE FROM auth_host WHERE PIP = '" . $PIP . "';";
    $db->do($str);
}

#functions for EIP management
#gets the next set of free EIP addresses, returns 0 if all are taken
sub get {
    #my $db = shift;
    my $query = $db->prepare("SELECT * FROM EIP_free limit 1");
    $query->execute();
    my $row;
    while ($row = $query->fetchrow_arrayref()) {
        my $EIP = @$row[0];
        $query->finish();
        my $str = "DELETE FROM EIP_free WHERE EIP = '" . $EIP . "';";
	$db->do($str); 
	return $EIP;
    }
    return "0";


}
#frees a set of EIP adresses
sub free {
    #my $db = shift;
    my $EIP = shift;
    #$db->do("CREATE TABLE EIP_free (EIP TEXT PRIMARY KEY)");
    my $str = "INSERT INTO EIP_free VALUES ('" . $EIP . "');";
    #DBD::SQLite::db do failed: UNIQUE constraint failed: EIP_free.EIP at db.pm line 148.
    $db->do($str);

}

#functions for managing de-elevated flows
#de-elevate this flow
sub deElevate {
    #my $db = shift;
    my $srcEIP = shift;
    my $dstEIP = shift;
    my $srcPIP = shift;
    my $dstPIP = shift;
    my $srcPort = shift;
    my $dstPort = shift;
    my $protocol = shift;
    my $timeStamp = shift;
    my $status = 0;
    my $str = "INSERT INTO de_elevated VALUES ('" . $srcEIP . "', '" . $dstEIP . "', '" . $srcPIP . "', '" . $dstPIP . "', '" . $srcPort . "', '" . $dstPort . "', '" . $protocol . "', '" . $timeStamp . "', '" . $status . "');";
    $db->do($str);
}

#update status of a flow
sub updateStatus{
    #my $db = shift;
    my $EIP = shift; #can be either src or dst
    my $status = shift;
    my $str = "UPDATE de_elevated SET status='" . $status . "' WHERE srcEIP = '" . $EIP . "' OR dstEIP = '" . $EIP . "';";
    $db->do($str);
}

#gets the status of a flow
sub getStatus{
    #my $db = shift;
    my $EIP = shift; #can be either src or dst
    my $query = $db->prepare("SELECT status FROM de_elevated WHERE srcEIP = '" . $EIP . "' OR dstEIP = '" . $EIP . "';");
    $query->execute();
    my $row;
    my @answer = qw();
    while ($row = $query->fetchrow_arrayref()) {
        my $status = @$row[0];
        $query->finish();
        return $status;
    }
}

#re-elevate this flow
sub reElevate{
    #my $db = shift;
    my $srcEIP = shift;
    my $str = "DELETE FROM de_elevated WHERE srcEIP = '" . $srcEIP . "';";
    $db->do($str);
}

#returns the EIP (src then dest) that correspond to the given PIP and port
sub getEIPs{
    #my $db = shift;
    my $PIP = shift;
    my $port = shift;
    my $query = $db->prepare("SELECT srcEIP, dstEIP FROM de_elevated WHERE (srcPIP = '" . $PIP . "' AND srcPort = '" . $port . "') OR (dstPIP = '" . $PIP . "' AND dstPort = '" . $port . "') ;");
    $query->execute();
    my $row;
    my @answer = qw();
    while ($row = $query->fetchrow_arrayref()) {
        push(@answer, @$row[0]);
        push(@answer, @$row[1]);
        print "srcEIP @$row[0] dstEIP @$row[1]\n";
        $query->finish();
        return @answer;
    }
}

#get info on this de-elevated flow, returns 0 if non-existant
sub getInfo{
    #my $db = shift;
    my $srcEIP = shift;
    my $query = $db->prepare("SELECT * FROM de_elevated WHERE srcEIP = '" . $srcEIP . "';");
    $query->execute();
    my $row;
    my @answer = qw();
    while ($row = $query->fetchrow_arrayref()) {
        push(@answer, @$row[0]);
        push(@answer, @$row[1]);
        push(@answer, @$row[2]);
        push(@answer, @$row[3]);
        push(@answer, @$row[4]);
        push(@answer, @$row[5]);
        push(@answer, @$row[6]);
        push(@answer, @$row[7]);
    }
    $query->finish();
    return @answer;

}

#get the srcEIPs of all of the de-eleavted flows
sub getAll{
    #my $db = shift;
    my $query = $db->prepare("SELECT srcEIP FROM de_elevated;");
    $query->execute();
    my $row;
    my @answer = qw();
    while ($row = $query->fetchrow_arrayref()) {
        push(@answer, @$row[0]);
    }
    $query->finish();
    return @answer;

}

1;
