=begin
use strict;
my $ip="10.22.0.4";
my $mac="52:54:00:dc:dd:4f";
dhcp_auth_hook("10",$ip, $mac);
=cut

use Time::HiRes qw(time);

sub dhcp_auth_hook{
my $start = time;
        my $command=shift;
        my $input=shift;
        my ($ip, $mac) = split(" ", $input);

        #my $target_subnet="10.22.0";

        # This is problematic. The file is occasionally removed to a backup file
        # If this file were large, this copy process can take place while
        # the moving of the original file happens.
        # If this becomes problematic, use library to let us read from the tail
        # of the file.
        my $ret=`sudo cp /var/lib/dhcp/dhcpd.leases /var/lib/dhcp/dhcpd.leases.auth`;
        open my $leases, "</var/lib/dhcp/dhcpd.leases.auth" or (warn $! and return 1);

        my %lease_hash={};

        while(my $outer_line = <$leases>){
                chomp($outer_line);
                if($outer_line =~m /lease $ip \{/){
                        my $state=0;
                        my $mac_found=0;
                        while(my $inner_line = <$leases>){
                                chomp($inner_line);
                                if($inner_line =~ m/^\{/){
                                        last;
                                }elsif($inner_line =~ m/^  binding state (.*);/){
                                        $state=$1;
                                }elsif($inner_line =~ m/hardware ethernet (.*);/){
                                        $mac_found=$1;
                                        if($mac_found eq $mac){
                                                # Assuming status always comes before hw
                                                $lease_hash{$ip}{$mac}=$state;
                                        }
                                }
                        }

                }
        }
        # Actually need to remove?
        $ret=`sudo rm /var/lib/dhcp/dhcpd.leases.auth`;

#        if(defined($lease_hash{$ip}{$mac}) and $lease_hash{$ip}{$mac} eq "active"){
#                print "Valid lease\n";
#                return 0;
#        } else{
#                print "Invalid lease\n";
#                return 1;
#        }
my $end = time;
print $end - $start, "\n";

return 0;
}

1;
