=begin
use strict;
my $pip="10.22.0.3";
my $eip="10.22.3.3";
eip_up("15",$pip,$eip);
=cut

sub findInterface1 {
	my $ip=shift;
	my $cmd = "/sbin/ifconfig |grep -B1 \"inet addr\" |awk '{ if ( \$1 == \"inet\" ) { print \$2 } else if ( \$2 == \"Link\" ) { printf \"%s:\" ,\$1 } }' |awk -F: '{ print \$1 \": \" \$3 }' | grep $ip | cut -d: -f1";
	my $inter= `$cmd`;

	chomp($inter);
	return $inter;
}

sub findFreeInterface1 {
	my $inter=shift;

	my $MAX_INTER=9999;

	my $cmd="/sbin/ifconfig |grep -B1 \"inet addr\" |awk '{ if ( \$1 == \"inet\" ) { print \$2 } else if ( \$2 == \"Link\" ) { printf \"%s:\" ,\$1 } }' | awk -F: '{ print \$1 \":\" \$2 }' | grep $inter | cut -d: -f2 | grep \"[0-9]\"";
	my $inter_numbers=`$cmd`;
	my @nums=split(/\n/,$inter_numbers);
	my %interHash = map { $_ => 1 } @nums;


	my $temp = $inter_numbers;
	chomp($inter_numbers);
	if($temp eq ""){
		return "$inter:0";
	}

	my $freeInt=0;
	while($freeInt<$MAX_INTER){
		if(exists($interHash{$freeInt})){
			$freeInt++;
		}else{
			return "$inter:$freeInt";
		}
	}
	print "ERROR: Max number of interfaces reached ($MAX_INTER)\n";
	return 1;
}

sub eip_up {
	my $command=shift;
	my $input=shift;
	my ($pip, $eip)=split(" ", $input);

	my $pip_interface = findInterface1($pip);
	if($pip_interface eq "") { print "No interface matching IP $pip\n"; return 1; }
	my $eip_interface=findFreeInterface1($pip_interface);
	if($eip_interface == -1) { print "No interface matching IP $pip\n"; return 1; }
	my $ret = system("ifconfig $eip_interface $eip netmask 255.255.255.252 up");

	if($ret == 0){ return 0; }
	else { return 1; }
}

1;
