




#!/usr/bin/perl

use strict;
use DBI;

my $db;

opendb();
create();
createFlow("111", "222", "80", "80", "tcp");
scan();
deElevate("111", "222", "80", "80", 0);
scan();

#This is the database for the policy manager, it maintains a list of all active flows, elevated or de-elevated

sub opendb{
    $db = DBI->connect(
        "dbi:SQLite:dbname=policy_manager.db",
        "",
        "",
        { RaiseError => 1 },
        ) or die $DBI::errstr;
}

sub get_db {
    return $db;
}

#create the table
sub create {
    #drop all tables
    $db->do("DROP TABLE IF EXISTS flow");
    #create tables
    #flag 0 = elevated, 1 = deelevated
    $db->do("CREATE TABLE flow (srcPIP TEXT NOT NULL, dstPIP TEXT NOT NULL, srcPort INT NOT NULL, dstPort INT NOT NULL, protocol TEXT NOT NULL, timeModified INT NOT NULL, flag INT)");
}

#functions for managing flows
#de-elevate this flow
sub createFlow {
    my $srcPIP = shift;
    my $dstPIP = shift;
    my $srcPort = shift;
    my $dstPort = shift;
    my $protocol = shift;
    my $timeStamp = time();
    my $flag = 0;
    my $str = "INSERT INTO flow VALUES ('" . $srcPIP . "', '" . $dstPIP . "', '" . $srcPort . "', '" . $dstPort . "', '" . $protocol . "', '" . $timeStamp . "', '" . $flag . "');";
    $db->do($str);
}

#flip the elevated flag for this flow
sub deElevate{
    my $srcPIP = shift;
    my $dstPIP = shift;
    my $srcPort = shift;
    my $dstPort = shift;
    my $flag = shift;# this will be the current flag, not what we want it to be
    #flip the flag as it has been dealt with
    if ($flag == 0){
	$flag = 1;
    }
    else {
	$flag = 0;
    }
    my $str = "UPDATE flow SET flag='" . $flag .  "', timeModified='" . time() ."'  WHERE srcPIP = '" . $srcPIP . "' AND dstPIP = '" . $dstPIP . "'AND srcPort = '" . $srcPort . "' AND dstPort = '" . $dstPort . "';";
    $db->do($str);
}

#returns the next flow that need to have an action done on them
sub scan{
    my $curr_time = time();
    my $timeBeforeFlip = 60;
    my $limit = $curr_time - $timeBeforeFlip;
    my $query = $db->prepare("SELECT srcPIP, dstPIP, srcPort, dstPort, flag FROM flow WHERE ( timeModified <= '" . $limit . "') ;");
    $query->execute();
    my $row;
    my @answer = qw();
    while ($row = $query->fetchrow_arrayref()) {
        push(@answer, @$row[0]);
        push(@answer, @$row[1]);
	push(@answer, @$row[2]);
	push(@answer, @$row[3]);
	push(@answer, @$row[4]);
	print @$row[0];
        print @$row[1];
        print @$row[2];
        print @$row[3];
        print @$row[4];
        $query->finish();
        return @answer;
    }
    print "none found";
}

1;
