#!/usr/bin/perl

use IO::Socket::INET;
use Class::Struct;

use Net::SNMP;

use COMMAND_TYPES;

use threads;
use Thread::Semaphore;
use threads::shared;

my $OID        :shared;
my @queue      :shared;
my $count_sem  :shared;
my $access_sem :shared;

$OID = '.1.3.6.1.4.1.7128.9999.9999.2';
@queue = ();
$count_sem = Thread::Semaphore->new(0);
$access_sem = Thread::Semaphore->new(1);

$| = 1;

# start execution
incoming();

sub incoming {

    my ($socket, $received_data);

    $socket = new IO::Socket::INET (
        LocalPort => '50003',
        Proto => 'udp',
    ) or die "ERROR in Socket Creation : $!\n";

    threads->create(\&handle_input, undef);

    while(1) {
        $socket->recv($received_data, 64);
        
        $access_sem->down();
        push(@queue, $received_data);
        print $received_data, "\n";
        $access_sem->up();

        $count_sem->up();

    }
    $socket->close();
}

sub handle_input {

    my $tuple;
    while(1) {
        $count_sem->down();

        $access_sem->down();
        $tuple = shift(@queue);
        print "Attempting to de-elevate $tuple\n";
        send_snmp(De_Elevate . " " . time() . " " . $tuple);
        $access_sem->up();

        sleep(5);
    }
    return 0;
}

sub send_snmp {
    
    my ($hostname, $username, $password) = ('10.22.2.3', 'controller', 'password');
    
    my $input = shift;
    
    my ($session, $error) = Net::SNMP->session(
                           -hostname      => $hostname,
                           -version       => '3',
                           -username      => $username,  # v3
                           -authpassword  => $password,  # v3
                           -authprotocol  => 'sha',      # v3
                           -privpassword  => $password,  # v3
                           -privprotocol  => 'aes',      # v3
                        );

    if (!defined $session) {
        printf "ERROR: %s.\n", $error;
        return 1;
    }

    my $result = $session->set_request(
                              -varbindlist => [ $OID, OCTET_STRING, $input ],
                           );

    unless(defined $result) {
        print $session->error(), "\n";
        return 1;
    }

    $session->close();
    
    return 0;
}
