#!/usr/bin/perl

use strict;
use warnings;
use Time::HiRes qw(usleep);

use lib ('/home/crtaylor/research/');
use COMMAND_TYPES;

my $interface="eth0"; #assumes client is using eth0
my $ipv4="inet addr:";
#my $ipv6="inet6 addr:";

my $DEBUG = 1;

while(1){
    my $ip=`ifconfig $interface | grep '$ipv4' | cut -d: -f2 | awk '{print \$1}'`;
    chomp($ip);
    if($ip ne ""){
        my $mac=`ifconfig $interface | grep 'HWaddr' | cut -d\\s  -f4 | awk '{print \$5}'`;
        chomp($mac);

        if($DEBUG){
            print "IP=$ip and MAC=$mac\n";
            print "I have a valid IP. Time to authenticate\n";
        }
        my $status=authenticate($ip,$mac);
        if($status == 0){
            print "Successfully authenticated to controller -- DHCP lease is valid\n";
            exit(0);
        } else{
            warn "Failed to authenticate to controller -- DHCP lease is invalid\n";
            exit(1);
        }
    }
    usleep(500);
}

sub authenticate {
	my $ip=shift;
	my $mac=shift;
	my $command = DHCP_Auth_Req_Controller . " " . time() . " " . $ip . " " . $mac;
	my $ret = system("perl snmp-host-sender.pl $command");
	my $logfile = '/home/crtaylor/client_poller_log.txt';
	open(my $lf, '>>', $logfile);
	print $lf "Attempting poller authentication at " . time() . "\n";

	while($ret !=0){
		sleep(5);
		print $logfile "DUPLICATE: Attempting poller authentication at " . time() . "\n";
		$ret=system("perl snmp-host-sender.pl $command");
	}
	close $lf;
}
