#!/usr/bin/perl

use strict;
use warnings;

use Net::SNMP;
#use NetSNMP::ASN (':all');

my $OID = '.1.3.6.1.4.1.7128.9999.9999.2';

die "Need at least one parameter!\n" unless scalar(@ARGV);

my $input = join(' ', @ARGV);
my ($hostname) = ('10.22.2.3');

#my $username = 'controller';
my $username = 'authOnly';
my $password = 'password';

my ($session, $error) = Net::SNMP->session(
                           -hostname      => $hostname,
                           -version       => '3',
                           -username      => $username,  # v3
                           -authpassword  => $password,  # v3
                           -authprotocol  => 'sha',      # v3
#                           -privpassword  => $password,  # v3
#                           -privprotocol  => 'aes',      # v3
                        );

if (!defined $session) {
    printf "ERROR: %s.\n", $error;
    exit(1);
}

$session->debug([0x04 | 0x08 | 0x10]);

my $logfile = '/home/crtaylor/client_snmp_sender_log.txt';
open(my $lf, '>>', $logfile);
print $lf time() . " Sending Message " . $input . "\n";
close $lf;

my $result = $session->set_request(
                          -varbindlist => [ $OID, OCTET_STRING, $input ],
                       );

unless(defined $result) {
    warn $session->error();
    exit(1);
}

$session->close();

exit(0);
