#!/usr/bin/perl

use strict;
use warnings;

use Switch;

use COMMAND_TYPES;
use forward_traffic;
# ??? hook

#die "not finished, import and use proper type and hook\n";

use NetSNMP::agent (':all');
use NetSNMP::ASN (':all');

$| = 1;

my $agent;
my $agent_name = "router-agent";
my $regat = '.1.3.6.1.4.1.7128.9999.9999.4';

sub handler {
    my ($handler, $registration_info, $request_info, $requests) = @_;
    my $request;

    for($request = $requests; $request; $request = $request->next()) {
        next unless ($request_info->getMode() == MODE_SET_ACTION); # only act in  this mode

        my $value = $request->getValue();                  # get command

        $value =~ m/^STRING:\s+"(.+)"/s;                   # remove ASN data type
        $value = $1;
        unless($value =~ m/^(\S+)\s+(\S+)\s+(.+)$/s) {     # match type, timestamp, remainder
            warn "error: $value is not properly formatted!\n";
            $request->setError($request_info, SNMP_ERR_BADVALUE);
            next;
        }
        my ($type, $timestamp, $remainder) = ($1, $2, $3); # retrieve type, timestamp, and remainder
	print "Received $type, $timestamp, $remainder\n";

        if(abs($timestamp - time()) > 3) {
		print "THE TIMESTAMP IS OFF!\n";
            $request->setError($request_info, SNMP_ERR_NOACCESS);
            next;
        }

        switch ($type) {
            
            case Forward_Traffic {
                $request->setError($request_info, SNMP_ERR_COMMITFAILED)
                    if(forward_traffic($type, $remainder));
            }
            else {
                warn "error: $type is not a known command type!\n";
                $request->setError($request_info, SNMP_ERR_BADVALUE);
                next;
            }
        }
    }
}

$agent = new NetSNMP::agent(
                        # makes the agent read a $agent_name.conf file
                        'Name' => $agent_name,
                        'AgentX' => 1
                        );

$agent->register($agent_name, $regat, \&handler);

$agent->main_loop();

warn "Router agent unexpectedly ended!\n";

exit(0);
