#!/usr/bin/python

from __future__ import print_function
import os
import sys
import time
import itertools

EXECDISABLED = False
clientbootsleeptime = 30 #seconds to wait for clients to reboot

class host:
	router = "localhost"
	controller = "10.22.2.3"
	policyman = "10.22.2.4"
	clientnet = "10.22.0."

class myv:
	mytime = str(time.time())
	newlogpath      = "~/panopt_logs/" + mytime
	newlogpath_full = "/home/crtaylor/panopt_logs/" + mytime
	curlogpath      = "~/panopt_logs/cur"
	curlogpath_full = "/home/crtaylor/panopt_logs/cur"
	codeall         = "~/cs558_fresh/code/all"
	codeall_full    = "/home/crtaylor/cs558_fresh/code/all"
	codescripts	= "/home/crtaylor/cs558_fresh/code/scripts"
	testname	= ""
	panoptlogpath	= curlogpath_full + "/panopt.log"
	panoptlogfd	= "" #open(panoptlogpath,"w")

# generate new time
def refreshTime():
	myv.mytime = str(time.time())

# Assist in identifying tests.
def nameTest(name):
	myv.testname = myv.mytime + "_" + name
	myv.newlogpath = "~/panopt_logs/" + myv.testname
	myv.newlogpath_full = "/home/crtaylor/panopt_logs/" + myv.testname


class mycolor:
	h = "\033[95m"
	b = "\033[94m"
	g = "\033[92m"
	w = '\033[93m'
	f = '\033[91m'
	ENDC = '\033[0m'

class runmode:
	argv		= ""
	restart		= "restart"
	fullauto	= "fullauto"
	myhelp		= "help"
	#dictionary to hold the appropriate options
	options		= { 'client_reboot_wait_seconds':'120', #FULLAUTO: time to wait for the client machines to reboot before continuing
			    'client_host_counts':'',            #FULLAUTO/RESTART: an array / simple integer for the number of clients to handle
			    'protocols':'',                     #FULLAUTO: an array of transport protocols to test with
			    'deelevation_mode':'',		#FULLAUTO: an array of possible values: "alwaysdown","alwaysup","cycle"
			    'rates':'',				#FULLAUTO: an array of kbps transfer rates 
			    'test_resume_number':0,		#FULLAUTO: an int, useful if wanting to start at a particular test permutation, starts at zero to init a loop counter
			    'reboot_clients':True		#FULLAUTO/RESTART: a boolean, dictates if we should reboot the clients or just simply start the perl scripts again
			  }

class errmsg:
	usage = "Usage: './panopt.py RUNMODE MODEOPTS'"
	mode_restart_usage = "Usage: './panopt.py restart client_host_count'"
	mode_fullauto_usage = "Usage: './panopt.py fullauto protocol(s) deelevation_mode client_host_count(s) rate(s) [test_num_to_resume_at] [reboot_clients=True/False]"  
	mode_fullauto_usage_ops = "FullAuto options: './panopt.py fullauto tcp,udp alwaysup,alwaysdown,cycle 2,4,6,8,10,12,... 1000,2000,9000,... 0,1,2,3,... True,False"  

def myexec(host,cmd):
	if host == "localhost":
		torun = cmd
	else:
		torun = "ssh " + host + " '" + cmd + " '"
	myprint(mycolor.g,"@" + host + "\t" + torun)
	if not EXECDISABLED: os.system(torun)

def myprint(color,message):
	print(color + message + mycolor.ENDC)

def mylog(logfile_fd,message):
	out=str(time.time()) + ": " + message
	if not True: #compications here I don't care to fix right now
		logfile_fd.write(out + '\n')
	else:
		myprint(mycolor.ENDC,"LogFile:\t" + out)


def systemcycle(clientCount,policyManSetting="cycle",rebootClients=True):

	## CLEAN UP ##
	# Kill Perls
	myprint( mycolor.w, "Performing Panopticon Restart" )
	myprint(mycolor.b,"Killing all open perl scripts")
	myexec(host.router,"sudo killall perl")
	myexec(host.router,"sudo killall monitor")
	myexec(host.controller,"sudo killall perl") 
	myexec(host.policyman,"sudo killall perl")
	
	for addr in range(0,clientCount):
		myexec(host.clientnet + str((addr*4)+100), "sudo killall perl")
	
	# Transfer Old Log Files--
	# We copy from ~/panopt_logs/cur/*
	# If it doesn't exist, it will simply fail and output the error then we move on
	#myprint(mycolor.b,"Pulling log files back to the router")
	#myexec(host.router,"scp " + host.controller + ":" + myv.curlogpath + "/* " + myv.curlogpath)
	#myexec(host.router,"scp " + host.policyman + ":" + myv.curlogpath + "/* " + myv.curlogpath)
	#for addr in range(0,clientCount):
		#myexec(host.router,"scp " + host.clientnet + str((addr*4)+100) + ":~/client_boot_log.txt " + myv.curlogpath + "/" + str((addr*4)+100) + "_client_boot_log.txt")
		#myexec(host.router,"scp " + host.clientnet + str((addr*4)+100) + ":~/client_snmp_host_log.txt " + myv.curlogpath + "/" + str((addr*4)+100) + "_client_snmp_host_log.txt")
		#myexec(host.router,"scp " + host.clientnet + str((addr*4)+100) + ":~/client_snmp_poller_log.txt " + myv.curlogpath + "/" + str((addr*4)+100) + "_client_snmp_poller_log.txt")
		#myexec(host.router,"scp " + host.clientnet + str((addr*4)+100) + ":~/client_snmp_sender_log.txt " + myv.curlogpath + "/" + str((addr*4)+100) + "_client_snmp_sender_log.txt")
		#myexec(host.clientnet + str((addr*4)+100),"sudo rm ~/client_snmp_sender_log.txt")
	
	## REFRESH SYSTEM ##
	myprint(mycolor.b,"Restoring an empty database for the contoller to use")
	myexec(host.controller,"cp " + myv.codeall + "/database_clean.db " + myv.codeall + "/database.db")
	
	myprint(mycolor.b,"Restarting SNMP Service")
	myexec(host.router,"sudo service snmpd restart")
	myexec(host.controller,"sudo service snmpd restart")
	myexec(host.policyman,"sudo service snmpd restart")
	
	# set up routing
	myprint(mycolor.b,"Enabling IPv4 Forwarding")
	myexec(host.router,"sudo sysctl net/ipv4/ip_forward=1")
	
	myprint(mycolor.b,"Configuring Routes (seeing messages about it existing are normal here)")
	myexec(host.router,"sudo route add -host 10.22.0.1 dev eth0")
	myexec(host.router,"sudo route add -net 10.22.0.0 netmask 255.255.0.0 gw 10.22.2.2 metric 10 dev eth0")
	
	# iptables 
	myprint(mycolor.b,"Flushing Router IPTables")
	myexec(host.router,"sudo iptables -F")
	myexec(host.router,"sudo iptables -t nat -F")
	
	myprint(mycolor.b,"Configuring IPTables")
	myexec(host.router,"sudo iptables -A OUTPUT -p icmp --icmp-type 5 -j DROP")
	myexec(host.router,"sudo iptables -A FORWARD -p udp -m udp --dport 161 -j ACCEPT")
	myexec(host.router,"sudo iptables -A FORWARD -p udp -m udp --sport 161 -j ACCEPT")
	myexec(host.router,"sudo iptables -P FORWARD DROP")
	myexec(host.router,"sudo iptables -A FORWARD --src 10.22.2.0/24  -j ACCEPT")
	myexec(host.router,"sudo iptables -A FORWARD --src 10.22.0.0/24 -p udp -j ACCEPT")
	myexec(host.router,"sudo iptables -A FORWARD --dst 10.22.0.1 -j ACCEPT")
	
	# create all the log folders
	myprint(mycolor.b,"Creating new logging folders")
	myexec(host.router,"mkdir -p " + myv.newlogpath)
	myexec(host.router,"ln -sfn " + myv.newlogpath_full + " " + myv.curlogpath_full)
	myexec(host.controller,"mkdir -p " + myv.newlogpath)
	myexec(host.controller,"ln -sfn " + myv.newlogpath_full + " " + myv.curlogpath_full)
	myexec(host.policyman,"mkdir -p " + myv.newlogpath)
	myexec(host.policyman,"ln -sfn " + myv.newlogpath_full + " " + myv.curlogpath_full)
	
	# Don't need because clients have log files in a particular place anyway
	#myprint(mycolor.b,"Creating new logging folders (on clients)")
	#for addr in range(0,clientCount):
	#	myexec(host.clientnet + str((addr*4)+100),"mkdir -p " + myv.newlogpath)
	#	myexec(host.clientnet + str((addr*4)+100),"ln -sfn " + myv.newlogpath_full + " " + myv.curlogpath_full)
	
	
	## START AGENTS ##
	myprint(mycolor.b,"Starting DHCP Agent, Router Agent, and Monitor")
	myprint(mycolor.g,"@localhost\t(chdir " + myv.codeall_full + ")")
	os.chdir(myv.codeall_full)
	myexec(host.router,"sudo perl snmp-router-agent.pl 2> " + myv.curlogpath + "/snmp-router-agent.log 1>&2 &")
	myexec(host.router,"sudo perl snmp-dhcp-agent.pl 2> " + myv.curlogpath + "/snmp-dhcp-agent.log 1>&2 &")
	myexec(host.router,"make")
	myexec(host.router,"sudo ./monitor 2> " + myv.curlogpath + "/monitor.log 1>&2 &")
	myexec(host.router,"make -C ~/cs558_fresh/code/all/udp_server")	

	myprint(mycolor.b,"Connecting to Controller and starting agent")
	myexec(host.controller,"cd " + myv.codeall_full + "; sudo perl snmp-controller-agent.pl 2> " + myv.curlogpath + "/snmp-controller-agent.log 1>&2 &")
	myprint(mycolor.b,"Connecting to Policy Manager and starting agent (policyManSetting=" + policyManSetting + ")")
	if policyManSetting == "cycle": myexec(host.policyman,"cd " + myv.codeall_full + "; sudo perl policy_manager.pl 2> " + myv.curlogpath + "/policy_manager.log 1>&2 &")
	elif policyManSetting == "alwaysdown": myexec(host.policyman,"cd " + myv.codeall_full + "; sudo perl policy_manager_down.pl 2> " + myv.curlogpath + "/policy_manager.log 1>&2 &")
	elif policyManSetting == "alwaysup": myprint(mycolor.g,"\tSkipping the Policy Manager, this test is supposed to have no de-elevation")
	else: sys.exit("!ERROR! BAD POLICYMANSETTING = " + poilcyManSetting)

	#print mycolor.FAIL + " - Start Controller Agents..." + mycolor.ENDC
	#print mycolor.FAIL + " - Start Policy Manager Agents..." + mycolor.ENDC
	
	# Reboot our client machines
	if rebootClients:
		myprint(mycolor.b,"Rebooting the client machines")
		for addr in range(0,clientCount):
			myexec(host.clientnet + str((addr*4)+100), "sudo reboot")
	else:
		myprint(mycolor.b,"Not rebooting clients, restarting their perl scripts")
		for addr in range(0,clientCount):
			myexec(host.clientnet + str((addr*4)+100), "sudo bash -c \"cd /home/crtaylor/cs558_choreo_pan/code/all; sudo perl snmp-host-agent.pl > /home/crtaylor/client_snmp_host_log.txt 2>&1 >> /dev/null &\"")
			myexec(host.clientnet + str((addr*4)+100), "cd /home/crtaylor/cs558_choreo_pan/code/all; sudo perl poller.pl 2>&1 >> /dev/null &");

	
# Main Code, first check we are crtaylor so that we can use the ssh keys
if os.geteuid() != 1000:
	sys.exit("\n*Need to run as crtaylor user for SSH keys to work!\n")

# Sanity check we have at least two parameters to work with here 
if len(sys.argv) < 2:
	sys.exit("Incorrect parameter count, " + errmsg.usage + ", see './panopt help' for more details.")

#save the sysargv for easier access
runmode.argv = sys.argv[1] 

# determine mode and then do the appropraite actions 
if( runmode.argv == runmode.myhelp ):
	print(errmsg.usage + "\n" + errmsg.mode_restart_usage + "\n" + errmsg.mode_fullauto_usage)

elif( runmode.argv == runmode.restart ):
	if len(sys.argv) < 3: sys.exit("Incorrect parameter count, " + errmsg.mode_restart_usage + ", see './panopt.py help' for more details.")
	clientCount = int(sys.argv[2]) # number of clients
	if ( clientCount % 2 != 0 ):
		sys.exit("Error- client host count must be divisible by 2.") 

	if( 4 <= len(sys.argv) ):
		systemcycle(clientCount,rebootClients=("True" == sys.argv[3]))
	else:
		systemcycle(clientCount)


elif( runmode.argv == runmode.fullauto ):
	if not ( (6 <= len(sys.argv) ) ): sys.exit("Incorrect parameter count, " + errmsg.mode_fullauto_usage + ", see './panopt.py help' for more details.")
	myprint( mycolor.w, "!! Starting Full Auto-Testing Mode !!" )
	runmode.options['protocols'] = sys.argv[2].split(',')
	runmode.options['deelevation_mode'] = sys.argv[3].split(',')
	runmode.options['client_host_counts'] = sys.argv[4].split(',')
	runmode.options['rates'] = sys.argv[5].split(',')
	if (7 <= len(sys.argv)):
		myprint(mycolor.b,"Setting Test Resume to Test #" + sys.argv[6])
		runmode.options['test_resume_number'] = int(sys.argv[6])
	if (8 <= len(sys.argv)):
		runmode.options['reboot_clients'] = ("True" == sys.argv[7])
		myprint(mycolor.b,"Rebooting Clients: " + str(runmode.options['reboot_clients']))

	print( runmode.options['protocols'] )
	print( runmode.options['deelevation_mode'] )
	print( runmode.options['client_host_counts'] )
	print( runmode.options['rates'] )
	
	for proto in runmode.options['protocols']:
		if not ((proto == "udp") or (proto == "tcp")):
			sys.exit("Invalid Protocol. Please type some conbination of 'tcp','udp','tcp,udp'")

	for mode in runmode.options['deelevation_mode']:
		if not ((mode == "alwaysup") or (mode == "alwaysdown") or (mode == "cycle")):
			sys.exit("Invalid Mode. Please type some conbination of 'alwaysup', 'alwaysdown', or 'cycle'")

	for i in runmode.options['client_host_counts']:
		if ( int(i) % 2 != 0 ):
			sys.exit("Error- client host count must be divisible by 2. Bad value of '" + i + "'") 

	combined = [runmode.options['protocols'],runmode.options['deelevation_mode'],runmode.options['client_host_counts'],runmode.options['rates'] ] 

	testCases = list(itertools.product(*combined))
	myprint( mycolor.w, "Running " + str(len(testCases)) + " Automated Tests" )
	mylog(myv.panoptlogfd,"Running in Automated Mode: " + str(len(testCases)) + " test cases to run, starting at case #" + str(runmode.options['test_resume_number']))
	
	# Write all test cases to the logfile, don't think we need this on the screen?
	count=0
	for item in testCases:
		mylog(myv.panoptlogfd,"Test Case #" + str(count) + " " + str(item))
		count = count + 1

	# allow use to use words instead of magic numbers	
	class index:
		proto = 0
		mode = 1
		clients = 2
		rate = 3
	
	# the big test loop!
	count=0
	for test in testCases:

		#skip to the appropriate test		
		if( count < runmode.options['test_resume_number'] ): 
			count += 1
			continue

		# start running all the tests, first rename` our logging path to a user-friendly one
		newname = test[index.proto] + "_" + test[index.mode] + "_" + test[index.clients] + "clients_" + test[index.rate] + "kpbs"
		nameTest(newname)
		testid = "#" + str(count) + " " + str(test) + " @ '" + myv.testname + "'"	
		
		mylog(myv.panoptlogfd,"Starting Test: " + testid)
		myprint(mycolor.b,"Preparing Test: " + testid)
		myprint(mycolor.b,"Rebooting Panopticon.." + " policyManSetting=" + test[index.mode])
		
		# reboot panopticon for the name change to take effect 
		systemcycle(int(test[index.clients]),policyManSetting=test[index.mode],rebootClients=runmode.options['reboot_clients'])
		if runmode.options['reboot_clients']: 
			myprint(mycolor.b,"Pausing " + str(clientbootsleeptime) + " seconds to give clients time to boot.")
			if not EXECDISABLED: time.sleep(clientbootsleeptime)

		# now run performance test
		myprint(mycolor.b,"System up, Running Test: " + testid)
		
		clientflows = ""
		for addr in range(0,int(test[index.clients])):
			clientflows = clientflows + host.clientnet + str((addr*4)+100) + " "
		exex = "~/doit_betterish " + test[index.proto] + "." + test[index.rate] + " " + clientflows
		print("Exex"+str(exex))
		myexec(host.router,"~/doit_betterish " + test[index.proto] + "." + test[index.rate] + " " + clientflows)
		count = count + 1

	myprint(mycolor.w,"Automated Tests Complete, ran " + str(len(testCases)) + " test(s).")

else:
	sys.exit("Incorrect runmmode '" + runmode.argv + "'. See './panopt help' for more details.")

