#!/bin/bash

if [[ $EUID -ne 0 ]]; then
	echo "*slap* run me as root!"
	exit 1
fi

# kill perl if it is running
echo "Killing all open perl scripts"
sudo killall perl

# Enable Forwarding
echo "Enabling IPv4 Forwarding"
echo "1" > /proc/sys/net/ipv4/ip_forward

# Configure routes
echo "Configuring Routes"
sudo route add -host 10.22.0.1 dev eth0
sudo route add -net 10.22.0.0 netmask 255.255.0.0 gw 10.22.2.2 metric 10 dev eth0

# Configure IPTables
sudo iptables -F
sudo iptables -t nat -F
sudo iptables -A OUTPUT -p icmp --icmp-type 5 -j DROP
sudo iptables -A FORWARD -p udp -m udp --dport 161 -j ACCEPT
sudo iptables -A FORWARD -p udp -m udp --sport 161 -j ACCEPT
# not needed unless DHCP is not on router i.e., doesn't hit forward chain sudo iptables  -A FORWARD -p udp --dport 67:68 --sport 67:68 -j ACCEPT
sudo iptables -P FORWARD DROP
sudo iptables -A FORWARD --src 10.22.2.0/24  -j ACCEPT
sudo iptables -A FORWARD --dst 10.22.0.1 -j ACCEPT
# Be safe and reboot snmp
sudo service snmpd restart

# Start our agents
codeall=~/cs558_fresh/code/all
logpath=~/panopt_logs/`date +%s.%N`

mkdir -p $logpath
cd $codeall

sudo perl snmp-router-agent.pl &> $logpath/snmp-router-agent.log &
sudo perl snmp-dhcp-agent.pl &> $logpath/snmp-dhcp-agent.log &

#make 
make 
sudo monitor > $logpath/monitor.log &

#iptables
sudo iptables -L -n > $logpath/router-iptables.log
sudo iptables -L -n

# and why not, let's diff
diffresult=`diff ~/panopt_logs/1397259706.544782936/router-iptables.log ~/How_Fresh_Iptables_Should_Look.txt`
if [[ $diffresult != "" ]]; then
	printf "\n\n\t!! Suspected IPTables Error, diff wasn't empty !!\n\n"
fi


