#!/bin/bash

num_args=$#
if [ $num_args -ne 1 ]; then
	echo "Usage : ./udp_rate_limit [1-1000000]"
	exit
fi

lower_limit=1
upper_limit=1000000
limit=$1

if [ $limit -gt $upper_limit ] || [ $limit -lt $lower_limit ]; then
	echo "Usage: ./udp_rate_limit [1-1000000]"
	exit
fi

/sbin/tc qdisc del dev eth0 root

/sbin/tc qdisc add dev eth0 root handle 1: htb default 99
/sbin/tc class add dev eth0 parent 1: classid 1:100 htb rate 1024mbps
/sbin/tc class add dev eth0 parent 1:100 classid 1:10 htb rate ${1}kbps ceil ${1}kbps
/sbin/tc class add dev eth0 parent 1:100 classid 1:11 htb rate ${1}kbps ceil ${1}kbps
/sbin/tc class add dev eth0 parent 1:100 classid 1:12 htb rate ${1}kbps ceil ${1}kbps
/sbin/tc class add dev eth0 parent 1:100 classid 1:13 htb rate ${1}kbps ceil ${1}kbps
/sbin/tc class add dev eth0 parent 1:100 classid 1:14 htb rate ${1}kbps ceil ${1}kbps
/sbin/tc class add dev eth0 parent 1:100 classid 1:15 htb rate ${1}kbps ceil ${1}kbps
/sbin/tc class add dev eth0 parent 1:100 classid 1:16 htb rate ${1}kbps ceil ${1}kbps
/sbin/tc class add dev eth0 parent 1:100 classid 1:17 htb rate ${1}kbps ceil ${1}kbps
/sbin/tc class add dev eth0 parent 1:100 classid 1:18 htb rate ${1}kbps ceil ${1}kbps
/sbin/tc class add dev eth0 parent 1:100 classid 1:19 htb rate ${1}kbps ceil ${1}kbps
/sbin/tc class add dev eth0 parent 1:100 classid 1:20 htb rate ${1}kbps ceil ${1}kbps
/sbin/tc class add dev eth0 parent 1:100 classid 1:21 htb rate ${1}kbps ceil ${1}kbps
/sbin/tc class add dev eth0 parent 1:100 classid 1:22 htb rate ${1}kbps ceil ${1}kbps
/sbin/tc class add dev eth0 parent 1:100 classid 1:23 htb rate ${1}kbps ceil ${1}kbps
/sbin/tc class add dev eth0 parent 1:100 classid 1:24 htb rate ${1}kbps ceil ${1}kbps
/sbin/tc class add dev eth0 parent 1:100 classid 1:25 htb rate ${1}kbps ceil ${1}kbps
/sbin/tc class add dev eth0 parent 1:100 classid 1:26 htb rate ${1}kbps ceil ${1}kbps
/sbin/tc class add dev eth0 parent 1:100 classid 1:27 htb rate ${1}kbps ceil ${1}kbps
/sbin/tc class add dev eth0 parent 1:100 classid 1:28 htb rate ${1}kbps ceil ${1}kbps
/sbin/tc class add dev eth0 parent 1:100 classid 1:99 htb rate 1000mbps ceil 1000mbps

/sbin/tc filter add dev eth0 protocol ip parent 1: prio 1 u32 match ip dport 40000 0xffff flowid 1:10
/sbin/tc filter add dev eth0 protocol ip parent 1: prio 1 u32 match ip dport 40001 0xffff flowid 1:11
/sbin/tc filter add dev eth0 protocol ip parent 1: prio 1 u32 match ip dport 40002 0xffff flowid 1:12
/sbin/tc filter add dev eth0 protocol ip parent 1: prio 1 u32 match ip dport 40003 0xffff flowid 1:13
/sbin/tc filter add dev eth0 protocol ip parent 1: prio 1 u32 match ip dport 40004 0xffff flowid 1:14
/sbin/tc filter add dev eth0 protocol ip parent 1: prio 1 u32 match ip dport 40005 0xffff flowid 1:15
/sbin/tc filter add dev eth0 protocol ip parent 1: prio 1 u32 match ip dport 40006 0xffff flowid 1:16
/sbin/tc filter add dev eth0 protocol ip parent 1: prio 1 u32 match ip dport 40007 0xffff flowid 1:17
/sbin/tc filter add dev eth0 protocol ip parent 1: prio 1 u32 match ip dport 40008 0xffff flowid 1:18
/sbin/tc filter add dev eth0 protocol ip parent 1: prio 1 u32 match ip dport 40009 0xffff flowid 1:19
/sbin/tc filter add dev eth0 protocol ip parent 1: prio 1 u32 match ip dport 40010 0xffff flowid 1:20
/sbin/tc filter add dev eth0 protocol ip parent 1: prio 1 u32 match ip dport 40011 0xffff flowid 1:21
/sbin/tc filter add dev eth0 protocol ip parent 1: prio 1 u32 match ip dport 40012 0xffff flowid 1:22
/sbin/tc filter add dev eth0 protocol ip parent 1: prio 1 u32 match ip dport 40013 0xffff flowid 1:23
/sbin/tc filter add dev eth0 protocol ip parent 1: prio 1 u32 match ip dport 40014 0xffff flowid 1:24
/sbin/tc filter add dev eth0 protocol ip parent 1: prio 1 u32 match ip dport 40015 0xffff flowid 1:25
/sbin/tc filter add dev eth0 protocol ip parent 1: prio 1 u32 match ip dport 40016 0xffff flowid 1:26
/sbin/tc filter add dev eth0 protocol ip parent 1: prio 1 u32 match ip dport 40017 0xffff flowid 1:27
/sbin/tc filter add dev eth0 protocol ip parent 1: prio 1 u32 match ip dport 40018 0xffff flowid 1:28

